var __rest = (this && this.__rest) || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
    t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
        t[p[i]] = s[p[i]];
    }
  return t;
};
import { h } from '@stencil/core';
import { isGranted } from './assets/lib/sparkleUtility';
import { AuthStore } from './stores/auth.store';
const Route = (_a) => {
  var { component, permission, render } = _a, props = __rest(_a, ["component", "permission", "render"]);
  const Component = component;
  return (h("stencil-route", Object.assign({}, props, { routeRender: (props) => {
      if (!AuthStore.state.isAuthenticated)
        return (h("stencil-router-redirect", { url: "/login" }));
      if (permission && !isGranted(permission)) {
        return (h("stencil-router-redirect", { url: "/unauthorized" }));
      }
      return Component ? h(Component, Object.assign({}, props, props.componentProps)) : render(props);
    } })));
};
export const PrivateRoute = Route;
